/*
 * info602, TP2 : générateurs pseudo aléatoires simples
 */

#include "tp2.h"
#include <assert.h>

/*
 * calcule l'inverse de a modulo m
 * (renvoie 0 si a n'est pas premier avec m ou si le résultat est incorrect)
 */
int64_t invert_mod(int64_t a, int64_t m) { return 0; }

/*
 * craque un générateur congruentiel dont le module est connu en calculant a
 * et c à partir des nombre générés
 *
 * Le tableau `random` contient les `nb` premiers nombres générés. La fonction
 * renvoie 1 si le calcul est possible, et 0 sinon (par exemple lorsque le
 * calcul demande une division par 0).
 */
int LCG_crack_ac(int nb, const int64_t* X, int64_t m, int64_t* a, int64_t* c)
{
    return 0;
}

/*
 * cherche un candidat pour le module d'un générateur congruentiel à partir
 * des nombre générés
 *
 * Le tableau `random` contient les `nb` premiers nombres générés. La fonction
 * renvoie 1 si le calcul est possible, et 0 sinon (par exemple lorsque `nb`
 * est trop petit).
 */
int LCG_crack_m(int nb, const int64_t* X, int64_t* m) { return 0; }

/*
 * vérifie que les paramètres a, c, m permettent de générer les nombres donnés
 *
 * Le tableau `random` contient les `nb` premiers nombres générés. La fonction
 * renvoie 1 si on retrouve bien les `nb` nombres donnes.
 */
int LCG_crack_check(int nb, const int64_t* X, int64_t m, int64_t a, int64_t c)
{
    return 0;
}

/*
 * diagonalise une matrice booléenne de taille n x n+1
 *
 * La fonction renvoie 1 si la matrice etait diagonalisable, et 0 sinon.
 * Dans le premier cas, le contenu du `M` à la fin de la fonction n'est pas
 * précisé. Dans le second cas, `M` contiendra la matrice diagonalisée.
 */
int gauss(word* M, int nb_lignes) { return 0; }

/*
 * craque un générateur linéaire "fibonacci" en cherchant les "taps" qui
 * permettent de regénérer la suite.
 * Le tableau 'X' contient les `nb` premiers bits générés par le
 * générateur.
 * La fonction renvoie 1 si les taps permettent de regénérer la suite, et 0
 * sinon.
 */
int LFSR_crack(int nb, const int* X, word* taps) { return 0; }
